

# We can run on Rhel 3'ish systems, but only if python2.3 is installed 
%if 0%{?rhel} == 3
%define __python_ver 2.3
%endif
%define python python%{?__python_ver}
%define __python /usr/bin/%{python}


%{!?python_version: %define python_version %(%{__python} -c "from distutils.sysconfig import get_python_version; print get_python_version()")}
%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

%define is_suse %(test -e /etc/SuSE-release && echo 1 || echo 0)


Summary: Remote certificate distribution framework
Name: certmaster
Version: 0.28
Release: 12%{?dist}
Source0: https://git.fedorahosted.org/cgit/certmaster.git/snapshot/%{name}-%{version}.tar.gz
Source1: %{name}.service
Source2: %{name}.logrotate-init
Source3: %{name}.logrotate-service
Patch0: certmaster-0.28-hostname.patch
License: GPLv2+
Group: Applications/System
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildArch: noarch
Url: https://fedorahosted.org/certmaster

%if 0%{?rhel} == 3
Requires: %{python}
Requires: pyOpenSSL-py23
%else
Requires: python >= 2.3
Requires: pyOpenSSL
%endif

# NOTE: if you 
BuildRequires: %{python}-devel
%if %is_suse
BuildRequires: gettext-devel
%else
%if 0%{?fedora} >= 8 || 0%{?rhel} >= 5
BuildRequires: python-setuptools
%endif
%endif
%if 0%{?fedora} >= 16 && 0%{?fedora} < 18
BuildRequires: systemd-units
Requires(post): systemd-sysv
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
%endif
%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
BuildRequires: systemd
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
%endif


%description
certmaster is a easy mechanism for distributing SSL certificates

%prep
%setup -q
%patch0 -p1 -b .hostname

%build
%{__python} setup.py build

%install
test "x$RPM_BUILD_ROOT" != "x" && rm -rf $RPM_BUILD_ROOT
%{__python} setup.py install --prefix=/usr --root=$RPM_BUILD_ROOT
ln -s ../../../../../..%{_bindir}/certmaster-sync $RPM_BUILD_ROOT/var/lib/certmaster/triggers/sign/post/certmaster-sync
ln -s ../../../../../..%{_bindir}/certmaster-sync $RPM_BUILD_ROOT/var/lib/certmaster/triggers/remove/post/certmaster-sync
touch $RPM_BUILD_ROOT/var/log/certmaster/certmaster.log
touch $RPM_BUILD_ROOT/var/log/certmaster/audit.log
rm -f $RPM_BUILD_ROOT/etc/logrotate.d/certmaster_rotate
install -D -p -m 0644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/certmaster

# systemd
%if 0%{?fedora} >= 16 || 0%{?rhel} >= 7
rm -rf $RPM_BUILD_ROOT/etc/init.d/
install -D -p -m 0644 %{SOURCE1} $RPM_BUILD_ROOT%{_unitdir}/certmaster.service
install -D -p -m 0644 %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/certmaster
%endif

%clean
rm -fr $RPM_BUILD_ROOT

%files
%defattr(-, root, root, -)
%if "%{python_version}"  >= "2.5"
%{python_sitelib}/certmaster*.egg-info
%endif
%{_bindir}/certmaster
%{_bindir}/certmaster-request
%{_bindir}/certmaster-ca
%{_bindir}/certmaster-sync
%if 0%{?fedora} >= 16 || 0%{?rhel} >= 7
%{_unitdir}/certmaster.service
%else
/etc/init.d/certmaster
%endif
%dir %{_sysconfdir}/%{name}
%dir %{_sysconfdir}/%{name}/minion-acl.d/
%dir %{_sysconfdir}/pki/%{name}
%config(noreplace) /etc/certmaster/minion.conf
%config(noreplace) /etc/certmaster/certmaster.conf
%config(noreplace) /etc/logrotate.d/certmaster
%config /etc/certmaster/version
%dir %{python_sitelib}/certmaster
%{python_sitelib}/certmaster/*.py*

%dir /var/log/certmaster
%attr(0600,root,root) %config %ghost %verify(not md5 size mtime) /var/log/certmaster/certmaster.log
%attr(0600,root,root) %config %ghost %verify(not md5 size mtime) /var/log/certmaster/audit.log

%attr(600,root,root) %dir /var/lib/certmaster
%attr(600,root,root) %dir /var/lib/certmaster/certmaster
%attr(600,root,root) %dir /var/lib/certmaster/certmaster/certs
%attr(600,root,root) %dir /var/lib/certmaster/certmaster/csrs
%dir /var/lib/certmaster/peers
%dir /var/lib/certmaster/triggers/sign/
%dir /var/lib/certmaster/triggers/sign/pre
%dir /var/lib/certmaster/triggers/sign/post
%dir /var/lib/certmaster/triggers/request/
%dir /var/lib/certmaster/triggers/request/pre
%dir /var/lib/certmaster/triggers/request/post
%dir /var/lib/certmaster/triggers/remove/
%dir /var/lib/certmaster/triggers/remove/pre
%dir /var/lib/certmaster/triggers/remove/post
/var/lib/certmaster/triggers/sign/post/certmaster-sync
/var/lib/certmaster/triggers/remove/post/certmaster-sync
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc AUTHORS README
%{_mandir}/man1/*.1.gz

%if 0%{?fedora} >= 18 || 0%{?rhel} >= 7
%post
%systemd_post %{name}.service
test -e /var/log/certmaster/certmaster.log || touch /var/log/certmaster/certmaster.log
test -e /var/log/certmaster/audit.log || touch /var/log/certmaster/audit.log
chmod 600 /var/log/certmaster/certmaster.log /var/log/certmaster/audit.log

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service
%else
%if 0%{?fedora} >= 16
%post
if [ $1 -eq 1 ] ; then 
    # Initial installation 
    /bin/systemctl daemon-reload >/dev/null 2>&1 || :
fi
test -e /var/log/certmaster/certmaster.log || touch /var/log/certmaster/certmaster.log
test -e /var/log/certmaster/audit.log || touch /var/log/certmaster/audit.log
chmod 600 /var/log/certmaster/certmaster.log /var/log/certmaster/audit.log

%preun
if [ $1 -eq 0 ] ; then
    # Package removal, not upgrade
    /bin/systemctl --no-reload disable certmaster.service > /dev/null 2>&1 || :
    /bin/systemctl stop certmaster.service > /dev/null 2>&1 || :
fi

%postun
/bin/systemctl daemon-reload >/dev/null 2>&1 || :
if [ $1 -ge 1 ] ; then
    # Package upgrade, not uninstall
    /bin/systemctl try-restart certmaster.service >/dev/null 2>&1 || :
fi

%triggerun -- certmaster < 0.28-2
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply certmaster
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save certmaster >/dev/null 2>&1 ||:

# Run these because the SysV package being removed won't do them
/sbin/chkconfig --del certmaster >/dev/null 2>&1 || :
/bin/systemctl try-restart certmaster.service >/dev/null 2>&1 || :

%else

%post
# for suse 
if [ -x /usr/lib/lsb/install_initd ]; then
  /usr/lib/lsb/install_initd /etc/init.d/certmaster
# for red hat distros
elif [ -x /sbin/chkconfig ]; then
  /sbin/chkconfig --add certmaster
# or, the old fashioned way
else
   for i in 2 3 4 5; do
        ln -sf /etc/init.d/certmaster /etc/rc.d/rc${i}.d/S99certmaster
   done
   for i in 1 6; do
        ln -sf /etc/init.d/certmaster /etc/rc.d/rc${i}.d/k01certmaster
   done
fi
test -e /var/log/certmaster/certmaster.log || touch /var/log/certmaster/certmaster.log
test -e /var/log/certmaster/audit.log || touch /var/log/certmaster/audit.log
chmod 600 /var/log/certmaster/certmaster.log /var/log/certmaster/audit.log

exit 0

%preun
if [ "$1" = 0 ] ; then
  /etc/init.d/certmaster stop  > /dev/null 2>&1
  if [ -x /usr/lib/lsb/remove_initd ]; then
    /usr/lib/lsb/remove_initd /etc/init.d/certmaster
  elif [ -x /sbin/chkconfig ]; then
    /sbin/chkconfig --del certmaster
  else
    rm -f /etc/rc.d/rc?.d/???certmaster
  fi
fi
%endif
%endif


%changelog
* Fri Apr 22 2016 Robert Scheck <robert@fedoraproject.org> - 0.28-12
- Fix daemon restarts via logrotate for initscripts and systemd
- Avoid creating log files ending with .rpmnew or .rpmsave (#695428)
- Add macro conditionals for Red Hat Enterprise Linux 7 (#1164784)
- Apply upstream patch to add missing --hostname option (#1069262)
- Introduce new systemd-rpm macros in certmaster spec file (#850055)

* Wed Feb 03 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.28-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Dec 12 2013 Rahul Sundaram <sundaram@fedoraproject.org> - 0.28-8
- https://fedoraproject.org/wiki/Changes/Remove_Python-setuptools-devel
- fix bogus dates in spec

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Sat Mar 30 2013 Kevin Fenzi <kevin@scrye.com> 0.28-6
- Rebuild to fix rawhide broken deps

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Jul 18 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Thu Jan 12 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.28-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Fri Sep  9 2011 Tom Callaway <spot@fedoraproject.org> - 0.28-2
- systemd support for f16+

* Thu Apr  7 2011 Seth Vidal <skvidal at fedoraproject.org> - 0.28-1
- 0.28

* Wed Aug 25 2010 Seth Vidal <skvidal at fedoraproject.org> - 0.27-1
- 0.27

* Thu Jun 11 2009 Adrian Likins <alikins@redhat.com> - 0.25-1
- add /etc/certmaster/func

* Tue May 26 2009 Adrian Likins <alikins@redhat.com> - 0.25-1
- add /var/lib/certmaster/certmaster* to spec and set perms
- add /var/log/certmaster/certmaster.log,audit.log to spec
  and set perms

* Wed Feb 18 2009 Adrian Likins <alikins@redhat.com> - 0.24.5
- remove version file

* Mon Jan 19 2009 Adrian Likins <alikins@redhat.com> - 0.24.4
- make inclusion of egginfo dependant on having python >= 2.5
- remove need for patch on rhel3+python2.4 cases (distutils should
  do all the /usr/bin/python renaming now)
- minor reformatting changes

* Tue Jan 06 2009 Greg Swift <gregswift@gmail.com> - 0.24-3x1
- Fixed spec because it was only building in rhel3

* Wed Dec 31 2008 Greg Swift <gregswift@gmail.com> - 0.24-2
- Patched SPEC to build on rhel3 with python2.3
- Added Patch0 to handle python2.3 if on rhel3

* Fri Dec 12 2008 Adrian Likins <alikins@redhat.com> - 0.24-1
- add missing dirs as per bz#473633

* Fri Jun 06 2008 Adrian Likins <alikins@redhat.com> - 0.20-2
- fix fedora bug #441283 - typo in postinstall scriptlet
  (the init.d symlinks for runlevels 1 and 6 were created wrong)

* Tue Apr 15 2008 Michael DeHaan <mdehaan@redhat.com> - 0.20-1
- new release
- fix changelog versions

* Tue Apr 15 2008 Steve Salevan <ssalevan@redhat.com> - 0.19-3
- added in trigger directories

* Mon Mar 17 2008 Adrian Likins <alikins@redhat.com> - 0.19-2
- removed unused minion/ and overlord/ dirs

* Mon Feb 25 2008 Adrian Likins <alikins@redhat.com> - 0.19-1
- remove certmasterd references

* Thu Feb 7 2008 Michael DeHaan <mdehaan@redhat.com> - 0.18-1
- initial version, split off from func project, WIP

